import type { App } from "vue";
import type { EditorConfiguration, Editor } from "codemirror";
import VueCodemirror from "./src/components/index.vue";
interface CmComp {
    cminstance: Editor;
    resize: (width?: string | number | null, height?: string | number | null) => void;
    refresh: () => void;
    destroy: () => void;
}
export type CmComponentRef = CmComp | null;
declare interface InstallConfig {
    options: EditorConfiguration;
    componentName: string;
}
declare const CodeMirror: typeof import("codemirror");
/**
 * Use global components.
 * @example
 * import { createApp } from "vue";
 * const app = createApp(App);
 * app.use(InstallCodemirro, { componentName: "customCodemirrorComponentName" });
 */
declare const GlobalCmComponent: (app: App, config?: InstallConfig) => App<any>;
declare const InstallCodemirro: (app: App, config?: InstallConfig) => App<any>;
export * from "./src/components/presetMode/log/utils";
export { CodeMirror, GlobalCmComponent, InstallCodemirro, VueCodemirror, };
export default VueCodemirror;
