import type { Ref } from "vue";
import type { Editor } from "codemirror";
import type { MergeView } from "codemirror/addon/merge/merge";
import type { CmProps } from '../..src/types/props';
export declare type UseViewControlParams = {
    props: CmProps;
    cminstance: Ref<Editor | MergeView | null>;
    presetRef: Ref<{
        initialize: () => void;
    } | null>;
};
export declare function useViewControl({ props, cminstance, presetRef }: UseViewControlParams): {
    reload: () => void;
    refresh: () => void;
    resize: (width?: string | number | null, height?: string | number | null) => void;
    destroy: () => void;
    containerWidth: Ref<string>;
    containerHeight: Ref<string>;
    reviseStyle: () => void;
};
